﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls;
using Telerik.WinControls.RadControlSpy;
using Telerik.WinControls.UI;

namespace _1481887GridCheckBoxShape
{
    public partial class RadForm1 : Telerik.WinControls.UI.RadForm
    {
        public RadForm1()
        {
            InitializeComponent(); new RadControlSpyForm().Show();


           // ((GridViewCheckBoxColumn)this.radGridView1.Columns["Discontinued"]).ThreeState = true;
            this.radGridView1.ViewCellFormatting += RadGridView1_ViewCellFormatting;


            this.radGridView1.EnableFiltering = true;
            this.radGridView1.CellMouseMove += RadGridView1_CellMouseMove;
        }

        private void RadGridView1_ViewCellFormatting(object sender, CellFormattingEventArgs e)
        {
            GridCheckBoxCellElement checkBoxCell = e.CellElement as GridCheckBoxCellElement;
            GridFilterCheckBoxCellElement filterCheckBoxCell = e.CellElement as GridFilterCheckBoxCellElement;
            if (checkBoxCell != null || filterCheckBoxCell!=null)
            {
                RadCheckBoxEditor editor = ((GridDataCellElement)e.CellElement).Editor as RadCheckBoxEditor;
                RadCheckBoxEditorElement el = editor.EditorElement as RadCheckBoxEditorElement;
                el.Checkmark.Shape = shape;
                el.Checkmark.CheckElement.CheckPrimitiveStyle = Telerik.WinControls.Enumerations.CheckPrimitiveStyleEnum.None;
                el.Checkmark.Fill.GradientStyle = GradientStyles.Solid;
                if (el.CheckState == Telerik.WinControls.Enumerations.ToggleState.On)
                {
                    el.Checkmark.Fill.BackColor = Color.Green;

                    el.Checkmark.CheckElement.ResetValue(LightVisualElement.BackColorProperty, ValueResetFlags.Local);
                    el.Checkmark.CheckElement.ResetValue(LightVisualElement.NumberOfColorsProperty, ValueResetFlags.Local);
                    el.Checkmark.CheckElement.ResetValue(LightVisualElement.GradientStyleProperty, ValueResetFlags.Local);
                    el.Checkmark.CheckElement.ResetValue(LightVisualElement.ForeColorProperty, ValueResetFlags.Local);
                }
                else if (el.CheckState == Telerik.WinControls.Enumerations.ToggleState.Off)
                {
                    el.Checkmark.Fill.BackColor = Color.Red;

                    el.Checkmark.CheckElement.ResetValue(LightVisualElement.BackColorProperty, ValueResetFlags.Local);
                    el.Checkmark.CheckElement.ResetValue(LightVisualElement.NumberOfColorsProperty, ValueResetFlags.Local);
                    el.Checkmark.CheckElement.ResetValue(LightVisualElement.GradientStyleProperty, ValueResetFlags.Local);
                    el.Checkmark.CheckElement.ResetValue(LightVisualElement.ForeColorProperty, ValueResetFlags.Local);
                }
                else
                {
                    el.Checkmark.Fill.ResetValue(LightVisualElement.BackColorProperty, ValueResetFlags.Local);

                    el.Checkmark.CheckElement.BackColor = Color.Black;
                    el.Checkmark.CheckElement.NumberOfColors = 1;
                    el.Checkmark.CheckElement.GradientStyle = GradientStyles.Solid;
                    el.Checkmark.CheckElement.ForeColor = Color.Transparent;
                }
            }
        }

        private void RadGridView1_CellMouseMove(object sender, MouseEventArgs e)
        {
            RadCheckmark elementUnderMouse = this.radGridView1.ElementTree.GetElementAtPoint(e.Location) as RadCheckmark;
            if (elementUnderMouse != null)
            {
                this.radGridView1.Cursor = Cursors.Hand; 
            }
            else
            {
                this.radGridView1.Cursor = Cursors.Default;
            }
        }

        private void RadForm1_Load(object sender, EventArgs e)
        {
            // TODO: This line of code loads data into the 'nwindDataSet.Products' table. You can move, or remove it, as needed.
            this.productsTableAdapter.Fill(this.nwindDataSet.Products);
            this.radGridView1.AutoSizeColumnsMode = GridViewAutoSizeColumnsMode.Fill;


        }

        StarShape shape = new StarShape();
        private void radGridView1_CellFormatting(object sender, CellFormattingEventArgs e)
        {
           
        }
    }
}
